import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Arrow here.
 * 
 * @author Taylor Born
 * @version July 2012
 */
public class Arrow extends Actor
{
    private static GreenfootImage blackArrow = new GreenfootImage("BlackArrow.png");
    private static GreenfootImage redArrow = new GreenfootImage("RedArrow.png");

    public Arrow()
    {
        setImage(blackArrow);
    }
    public void act()
    {
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if (Greenfoot.mouseMoved(null) || Greenfoot.mouseDragged(null))
            setLocation(mouse.getX() - mouse.getX() % Mark.SPACING + Mark.SPACING / 2, getY());
        if (getY() == Mark.SPACING / 2)
        {
            if (!columnIsClear())
                setLocation(getX(), -Mark.SPACING / 2);
            
            if (((Board)getWorld()).isReady() && getY() == Mark.SPACING / 2 && Greenfoot.mousePressed(null))
            {
                ((Board)getWorld()).placeMarker(getX());
                if (getImage() == blackArrow)
                    setImage(redArrow);
                else
                    setImage(blackArrow);
                setLocation(getX(), getY() - Mark.SPACING);
            }
        }
        else
        {
            if (((Board)getWorld()).isReady() && columnIsClear())
                setLocation(getX(), Mark.SPACING / 2);
        }
    }
    private boolean columnIsClear()
    {
        return getWorld().getObjectsAt(getX(), (int)(Mark.SPACING * 1.5), Mark.class).isEmpty();
    }
}