import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Write a description of class Board here.
 * 
 * @author Taylor Born
 * @version July 2012
 */
public class Board extends World
{
    private int turn;
    private Mark mark;
    private static final int CODE_ID = 62;

    public Board()
    {
        super(350, 350, 1, false);
        setPaintOrder(CodeDisplay.class, Cover.class);
        CodeKeyUser.enter();
        newGame();
        Greenfoot.start();
    }
    public void act()
    {
        if (Greenfoot.isKeyDown("F2"))
            newGame();
    }
    private void newGame()
    {
        turn = 0;
        removeObjects(getObjects(null));
        mark = null;
        addObject(new Arrow(), 25, -25);
        addObject(new Cover(), getWidth() / 2, getHeight() / 2);
    }
    public void placeMarker(int x)
    {
        mark = new Mark(turn);
        addObject(mark, x, 25);
        if (turn != -1)
            turn = 1 - turn;
    }
    public void win()
    {
        turn = -1;
        if (CodeGenerator.haveUser())
        {
            removeObjects(getObjects(CodeDisplay.class));
            addObject(new CodeDisplay(CODE_ID), getWidth() / 2, 45);
        }
    }
    public boolean isReady()
    {
        return mark == null && turn != -1;
    }
    public void continueOn()
    {
        mark = null;
    }
}