import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Mark here.
 * 
 * @author Taylor Born
 * @version July 2012
 */
public class Mark extends Actor
{
    public static final int SPACING = 50;
    private static final GreenfootImage black = new GreenfootImage("Black.png");
    private static final GreenfootImage red = new GreenfootImage("Red.png");
    private int turn;
    private boolean highlighted;
    private boolean fadeIn;
    private boolean falling = true;
    private int speed = 1;

    public Mark(int t)
    {
        turn = t;
        setImage(new GreenfootImage(t == 0 ? black : red));
    }
    public void act()
    {
        if (falling)
        {
            speed += 1;
            for (int i = 0; i < speed; i++)
                if (getY() < getWorld().getHeight() - SPACING / 2 && getObjectsAtOffset(0, SPACING / 2, Mark.class).isEmpty())
                    setLocation(getX(), getY() + 1);
                else
                {
                    falling = false;
                    ((Board)getWorld()).continueOn();
                    if (connectsFour())
                    {
                        ((Board)getWorld()).win();
                        goHighlight();
                    }
                }
        }
        if (highlighted)
            if (fadeIn)
            {
                getImage().setTransparency(getImage().getTransparency() + 5);
                if (getImage().getTransparency() == 255)
                    fadeIn = false;
            }
            else
            {
                getImage().setTransparency(getImage().getTransparency() - 5);
                if (getImage().getTransparency() == 0)
                    fadeIn = true;
            }
    }
    private boolean connectsFour()
    {
        return check(-1, 0) || check(-1, -1) || check(0, -1) || check(1, -1);
    }
    private boolean check(int xd, int yd)
    {
        return checkDirection(xd, yd, 1) + 1 + checkDirection(-xd, -yd, 1) >= 4;
    }
    private int checkDirection(int xd, int yd, int step)
    {
        Mark m = (Mark)getOneObjectAtOffset(step * xd * SPACING, step * yd * SPACING, Mark.class);
        if (m == null || m.getTurn() != turn)
            return 0;
        return 1 + checkDirection(xd, yd, step + 1);
    }
    public int getTurn()
    {
        return turn;
    }
    private void goHighlight()
    {
        highlight();
        goHighlightIn(-1, 0);
        goHighlightIn(-1, -1);
        goHighlightIn(0, -1);
        goHighlightIn(1, -1);
    }
    private void goHighlightIn(int xd, int yd)
    {
        if (!check(xd, yd))
            return;
        highlight(xd, yd, 1);
        highlight(-xd, -yd, 1);
    }
    private void highlight(int xd, int yd, int step)
    {
        Mark m = (Mark)getOneObjectAtOffset(step * xd * SPACING, step * yd * SPACING, Mark.class);
        if (m != null && m.getTurn() == turn)
        {
            m.highlight();
            highlight(xd, yd, step + 1);
        }
    }
    public void highlight()
    {
        highlighted = true;
    }
}